package core.schedules;

import core.entities.User;
import core.repositories.timemanager.ScheduleRepository;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.boot.test.autoconfigure.orm.jpa.TestEntityManager;
import org.springframework.test.context.jdbc.Sql;
import org.springframework.test.context.jdbc.SqlGroup;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import static org.junit.jupiter.api.Assertions.assertEquals;

@ExtendWith(SpringExtension.class)
@DataJpaTest
public class ScheduleRepositoryTest {

    @Autowired private ScheduleRepository scheduleRepository;
    @Autowired private TestEntityManager entityManager;
    @Test
    @SqlGroup({
            @Sql("classpath:taskgroupRepositoryTestEntries.sql"),
            @Sql("classpath:taskRepositoryEntries.sql"),
            @Sql("classpath:basicScheduleEntries.sql")
    })
    void getAllSchedulesOfUser() {
        User referenceUser_1 = entityManager.find(User.class, 1L);
        User referenceUser_2 = entityManager.find(User.class, 2L);

        assertEquals(0, scheduleRepository.findAllByUsername(referenceUser_2.getUsername()).size());
        assertEquals(3, scheduleRepository.findAllByUsername(referenceUser_1.getUsername()).size());
    }
}
